/*$Id: barajar.c,v 1.1 2004/04/18 20:29:31 mundacho Exp mundacho $*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include "barajar.h"

char *palos[] = {"espadas","bastos","oros", "copas"};
struct tms t;

BARAJA *barajar_cartas(BARAJA *a) /*devuelve un puntero a la lista desordenada*/
{
	BARAJA *b, *r, *q;/*r para recorrer, q apunta al elemento tomado como*/
			/*primero, b para sacar la carta*/
	int i=0;
	r = NULL;
	srandom(times(&t)); /*ponemos la semilla de acuerdo al tiempo*/
	for (i = 0;i < CARTAS; i++){ 
		b = sacar_carta(a, random()%CARTAS);
		a = b->sig;
		if (r == NULL){
			q = r = b;
		}
		else {
			r->sig = b;
			r = r->sig;
		}
	}
	r->sig = q;
	return q;
	
}

BARAJA *crear_baraja(void) /* inicializa una baraja espaola para poder*/
			/*trabajar con ella*/
{
	BARAJA *b, *q, *r; /* b para crear cada nueva carta, q va apuntar al
				primer elemento de la lista, en  y r va
				recorriendo*/
	int i,j;
	q = b = r = NULL;
	for (i=0; i<sizeof(*palos);i++){
		for (j=1;j<=12;j++){
			if (j == 8 || j == 9) { continue;}
			b = nueva_carta();
			b->nro =  j;
			b->palo = i;
			if (q == NULL){ r = q = b; }
			else {
				r->sig = b;
				r = r->sig;
			}
		}
	}
	r->sig= q; /*cerramos el crculo*/
	return q;
}
BARAJA *nueva_carta(void) /*devuelve un nuevo nodo para la lista*/
{ return (BARAJA *)malloc(sizeof(BARAJA)); }
BARAJA *sacar_carta(BARAJA *a, int k) /*esta funcin saca el k-simo nodo de la*/
				/*lista enlazada circular y lo devuelve*/
				/* dejando la lista como estaba*/
				/*advertencia: puede sacar el primer nodo de */
				/*la lista: usar con cuidado en loops*/
{
	BARAJA *p; /*p apunta al de atras*/
	/*usamos a para recorrer la baraja, porque slo es una copia del 
	puntero original*/
	if (k == 0) { k = 1;}
	if ( k== 1){/*tiene que dar toda la vuelta para poder dar la primera*/
			/*carta*/
		BARAJA *q;
		q = a;
		do {
			p=a;
			a=a->sig;
		} while (q != a);
	}
	while(k > 1){
		p=a;
		a=a->sig;
		k--;
	}
	p->sig = a->sig;
	return a;
}
void imprimir_baraja(BARAJA *a)
{
	BARAJA *r;
	r = a;/*a es el comienzo*/
	do {
		printf("%d de %s\n",r->nro, palos[r->palo]);
		r = r->sig;
	}while (r!=a);/*hasta que vuelva al comienzo*/
}
void liberar_baraja(BARAJA *a){
	BARAJA *q, *b;
	q = b = a;
	do {
		a = b->sig; /*empieza liberando la 2da*/
		b = sacar_carta(a,1);/*va a sacar las cartas una a una*/
		if (b == q) {break;}
		free(b);
	} while (1);
	free(b); /*Libera la primera/ltima carta*/
}
